VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDateUtilities"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'/*************************************/
'/* Author: Morgan Haueisen           */
'/*         morganh@hartcom.net       */
'/*                                   */
'/* Copyright (c) 1998-2002           */
'/*************************************/
Option Explicit

'/* Return the number of business days between two dates */
Public Function RetBusDays(ByVal StartDate As Date, ByVal EndDate As Date) As Integer
  Dim i As Integer, tDate As Date

    If CDate(EndDate) < CDate(StartDate) Then
        tDate = EndDate
        EndDate = StartDate
        StartDate = tDate
    End If
        
    Do Until StartDate = EndDate
        Select Case Weekday(StartDate)
            Case 2, 3, 4, 5, 6
            i = i + 1
        End Select
        StartDate = DateAdd("d", 1, StartDate)
    Loop
    RetBusDays = i

End Function

'/* Returns the age in the format 'YY.MM' */
Public Function RetAge(ByVal DateOfBirth As Date, Optional ByVal ReferenceDate As Date) As String
 Dim StartDate As Date
 Dim MN As Integer, Yr As Integer
   
    On Local Error Resume Next
    
    If Not IsMissing(ReferenceDate) Then
       StartDate = CDate(ReferenceDate)
    Else
       StartDate = Date
    End If
    
    If IsDate(DateOfBirth) Then
        Yr% = Int(DateDiff("y", DateOfBirth, StartDate) / 365.25)
        MN% = Int(DateDiff("m", DateOfBirth, StartDate))
        MN% = MN% - (Yr% * 12)
        
        If MN% = 12 Then
            Yr% = Yr% + 1
            MN% = 0
        End If
        
        RetAge = Format(Yr%) & "." & Format(MN%)
    Else
        RetAge = "?"
    End If
    
    On Local Error GoTo 0

End Function

Private Function DaylightSavingsTime(Optional ByVal CheckDate As Variant) As Boolean
  Dim dDS_Start As Date, dDS_End As Date
    
    If IsMissing(CheckDate) Then CheckDate = Now
    CheckDate = CDate(CheckDate)
    
    dDS_Start = CDate("4/1/" & Year(CheckDate) & " 01:00:00")
    Do
        If Weekday(dDS_Start) <> vbSunday Then
            dDS_Start = DateAdd("d", 1, dDS_Start)
        Else
            Exit Do
        End If
    Loop
    
    dDS_End = CDate("10/31/" & Year(CheckDate) & " 02:00:00")
    Do
        If Weekday(dDS_End) <> vbSunday Then
            dDS_End = DateAdd("d", -1, dDS_End)
        Else
            Exit Do
        End If
    Loop
    
    If Now > dDS_Start And Now < dDS_End Then
        DaylightSavingsTime = True
    Else
        DaylightSavingsTime = False
    End If

End Function

Public Function RetBeginOfWeek(ByVal InDate As Date, Optional WhatDay As VbDayOfWeek = vbMonday)
    '/* Returns the first day in the week of the date passed. */
    RetBeginOfWeek = InDate - Weekday(InDate, WhatDay) + 1
End Function

Public Function WeeksInAYear(Optional ByVal FirstDayOfYear As Variant, _
                            Optional ByVal CurrentYear As Variant, _
                            Optional WeekStartsOn As VbDayOfWeek = vbUseSystemDayOfWeek) As Integer
  
  Dim tDate As Date
    
    If IsMissing(FirstDayOfYear) Then
        If IsMissing(CurrentYear) Then CurrentYear = Year(Date)
        FirstDayOfYear = CDate("1/1/" & CurrentYear)
    Else
        If WeekStartsOn = vbUseSystemDayOfWeek Then
            WeekStartsOn = Weekday(FirstDayOfYear)
        End If
    End If
    
    tDate = DateAdd("yyyy", 1, FirstDayOfYear) + 6
    If Day(tDate) > 6 Then tDate = tDate - 7
    WeeksInAYear = DateDiff("w", FirstDayOfYear, tDate, WeekStartsOn)
    
End Function

Public Function RetShift(Optional ByVal DateTime As Variant)
  Dim sTime As String
    
    If IsMissing(DateTime) Then DateTime = Time
    If Not IsDate(DateTime) Then DateTime = Time
    
    sTime = Format(DateTime, "hh:mm:ss")
    If sTime >= "08:00:00" And sTime <= "16:00:00" Then
        RetShift = 1
    ElseIf sTime < "08:00:00" Then
        RetShift = 3
    Else
        RetShift = 2
    End If
    
End Function

'/* Return the Last day in the week number provided */'
Public Function RetLastDay(ByVal WeekNumber As Integer, _
                            Optional ByVal FirstDayOfYear As Variant, _
                            Optional ByVal CurrentYear As Variant, _
                            Optional WeekStartsOn As VbDayOfWeek = vbUseSystemDayOfWeek)
                            
  Dim LastDay As Variant
  
    If IsMissing(FirstDayOfYear) Then
        If IsMissing(CurrentYear) Then CurrentYear = Year(Date)
        FirstDayOfYear = CDate("1/1/" & CurrentYear)
    Else
        FirstDayOfYear = CDate(FirstDayOfYear)
        If WeekStartsOn = vbUseSystemDayOfWeek Then
            WeekStartsOn = Weekday(FirstDayOfYear)
        End If
    End If
    
    LastDay = FirstDayOfYear - Weekday(FirstDayOfYear, WeekStartsOn) + 1
    LastDay = LastDay + ((WeekNumber - 1) * 7)
    LastDay = DateAdd("d", 6, LastDay)
    RetLastDay = Format(LastDay, "mm/dd/yyyy")
    
End Function

Public Function WeekDaysInMonth(ByVal InDate As Date, Optional WhatWeekDay As VbDayOfWeek = vbUseSystemDayOfWeek)
 Dim M As Integer, Y As Integer, i As Byte
 Dim StartWeek As Integer, EndWeek As Integer
  
    M = Month(InDate)
    Y = Year(InDate)
    
    For i = 1 To 31
       InDate = CDate(CStr(M) & "/" & CStr(i) & "/" & CStr(Y))
       If Weekday(InDate) = WhatWeekDay Then Exit For
    Next i
    StartWeek = DatePart("ww", InDate, WhatWeekDay, vbFirstFullWeek)
    
    InDate = DateAdd("ww", 1, InDate)
    For i = 1 To 5
       If M = Month(InDate) Then
           InDate = DateAdd("ww", 1, InDate)
       Else
           Exit For
       End If
    Next i
    InDate = DateAdd("ww", -1, InDate)
    EndWeek = DatePart("ww", InDate, WhatWeekDay, vbFirstFullWeek) + 1
    
    WeekDaysInMonth = EndWeek - StartWeek
    
End Function

Public Function RetWeekNumber(ByVal InDate As Date, _
                              Optional ByVal FirstDayOfYear As Variant, _
                              Optional WeekStartsOn As VbDayOfWeek = vbUseSystemDayOfWeek)
                                
    
  Dim a As Integer, B As Integer
    
    If IsMissing(FirstDayOfYear) Then
        FirstDayOfYear = CDate("1/1/" & Year(InDate))
    Else
        FirstDayOfYear = CDate(FirstDayOfYear)
        If WeekStartsOn = vbUseSystemDayOfWeek Then
            WeekStartsOn = Weekday(FirstDayOfYear)
        End If
    End If
    
    FirstDayOfYear = FirstDayOfYear - Weekday(FirstDayOfYear, WeekStartsOn) + 1
    a = DateDiff("ww", FirstDayOfYear, InDate - Weekday(InDate, WeekStartsOn) + 1) + 1
    B = WeeksInAYear(FirstDayOfYear)
    If a > B Then a = B
    RetWeekNumber = a
End Function

'/* Return the first day in the week number provided */
Public Function RetFirstDay(ByVal WeekNumber As Integer, _
                            Optional ByVal FirstDayOfYear As Variant, _
                            Optional ByVal CurrentYear As Variant, _
                            Optional WeekStartsOn As VbDayOfWeek = vbUseSystemDayOfWeek) As Variant
                            
    
    If IsMissing(FirstDayOfYear) Then
        If IsMissing(CurrentYear) Then CurrentYear = Year(Date)
        FirstDayOfYear = CDate("1/1/" & CurrentYear)
    Else
        FirstDayOfYear = CDate(FirstDayOfYear)
        If WeekStartsOn = vbUseSystemDayOfWeek Then
            WeekStartsOn = Weekday(FirstDayOfYear)
        End If
    End If
    
    FirstDayOfYear = FirstDayOfYear - Weekday(FirstDayOfYear, WeekStartsOn) + 1
    RetFirstDay = Format(FirstDayOfYear + ((WeekNumber - 1) * 7), "mm/dd/yyyy")
    
End Function


'/* Fill a Listbox or ComboBox with a list of weeks in a year */
Public Sub FillControlDates(Obj As Object, _
                            Optional ByVal FirstDayOfYear As Variant, _
                            Optional ByVal SetToDay As Boolean = False, _
                            Optional ByVal ShowFirstDayOfWeek As Boolean = False, _
                            Optional ByVal CurrentYear As Variant, _
                            Optional WeekStartsOn As VbDayOfWeek = vbUseSystemDayOfWeek)

  Dim i As Integer
    
    Obj.Clear
    If IsMissing(FirstDayOfYear) Then
        If IsMissing(CurrentYear) Then CurrentYear = Year(Date)
        FirstDayOfYear = RetFirstDayOfYear(WeekStartsOn, CurrentYear)
        'FirstDayOfYear = CDate("1/1/" & Year(Date))
    Else
        FirstDayOfYear = CDate(FirstDayOfYear)
    End If
    
    
    For i = 1 To WeeksInAYear(FirstDayOfYear)
        If ShowFirstDayOfWeek Then '/* Display Beginning of Week */
            Obj.AddItem Format(RetFirstDay(i, FirstDayOfYear), "mm/dd/yyyy")
            Obj.ItemData(Obj.NewIndex) = i
        Else '/* Display End Of Week */
            Obj.AddItem Format(RetLastDay(i, FirstDayOfYear), "mm/dd/yyyy")
            Obj.ItemData(Obj.NewIndex) = i
        End If
    Next i
    
    On Error Resume Next
    If SetToDay Then
        i = RetWeekNumber(Date, FirstDayOfYear) - 1
        If i <= Obj.ListCount Then
            If i >= 0 Then Obj.ListIndex = i Else Obj.ListIndex = 0
        Else
            Obj.ListIndex = Obj.ListCount - 1
        End If
    Else
        Obj.ListIndex = 0
    End If
    On Error GoTo 0
End Sub


Public Function Julian2WeekNo(ByVal JulianDay As Variant)
    JulianDay = Val(JulianDay)
    JulianDay = (JulianDay / 7)
    If JulianDay - Int(JulianDay) > 0 Then JulianDay = JulianDay + 1
    Julian2WeekNo = Int(JulianDay)
End Function

Public Function Date2Julian(ByVal InDate As Variant, _
                            Optional ByVal FirstDayOfYear As Variant)
    
    If InDate = vbNullString Then InDate = Date
    InDate = CDate(InDate)
    If IsMissing(FirstDayOfYear) Then
        FirstDayOfYear = CDate("1/1/" & Year(InDate))
    Else
        FirstDayOfYear = CDate(FirstDayOfYear)
    End If
    
    If InDate - FirstDayOfYear >= 0 Then
        Date2Julian = InDate - FirstDayOfYear + 1
    Else
        Date2Julian = InDate - FirstDayOfYear
    End If
End Function

Public Function Julian2Date(ByVal JulianDay As Variant, _
                                Optional ByVal FirstDayOfYear As Variant, _
                                Optional CurrentYear As Variant)

    If IsMissing(FirstDayOfYear) Then
        If IsMissing(CurrentYear) Then CurrentYear = Year(Date)
        FirstDayOfYear = CDate("1/1/" & CurrentYear)
    Else
        FirstDayOfYear = CDate(FirstDayOfYear)
    End If

    Julian2Date = Format(FirstDayOfYear + JulianDay - 1, "mm/dd/yyyy")

End Function

'/* Use the +/- keys to change the date in a TextBox */
Public Sub PlusKey(TxtBox As TextBox, KeyAscii As Integer, Optional LimitToYear As Boolean = False, Optional AllowEdit As Boolean = True, Optional ByVal FirstDayOfYear As Variant)
  '/* Needs to be placed in the KeyPress event of the text box           */
  '/* Need to place KeyCode=False in KeyDown event to disable Delete key */
  '/* or set the TxtBox.Locked=True                                      */
  Dim n As Date, tYear As String
    
    If IsMissing(FirstDayOfYear) Then FirstDayOfYear = RetFirstDayOfYear
    
    Select Case KeyAscii
    Case 43 '/* "+"
        If Not IsDate(TxtBox) Then TxtBox = Format(Date, "mm/dd/yyyy")
        n = CDate(TxtBox)
        tYear = Year(n)

        n = DateAdd("d", 1, n)
        If LimitToYear Then
            If CDate(n) > FirstDayOfYear Then n = DateAdd("d", -364, n)
            If CDate(n) < FirstDayOfYear Then n = DateAdd("d", 364, n)
        End If
        TxtBox = Format(n, "mm/dd/yyyy")
        KeyAscii = False
    Case 45 '/* "-"
        If Not IsDate(TxtBox) Then TxtBox = Format(Date, "mm/dd/yyyy")
        n = CDate(TxtBox)
        tYear = Year(n)
        
        n = DateAdd("d", -1, n)
        If LimitToYear Then
            If CDate(n) > FirstDayOfYear Then n = DateAdd("d", -364, n)
            If CDate(n) < FirstDayOfYear Then n = DateAdd("d", 364, n)
        End If
        TxtBox = Format(n, "mm/dd/yyyy")
        KeyAscii = False
    Case 13, 9 '/* Enter, Tab
        If Not IsDate(TxtBox) Then TxtBox = Format(Date, "mm/dd/yyyy")
        n = CDate(TxtBox)
        tYear = Year(n)
        
        KeyAscii = False
        SendKeys "{TAB}"
    Case Else
        If AllowEdit Then
            If InStr("0123456789/" & Chr(8), Chr(KeyAscii)) = False Then KeyAscii = False
        Else
            KeyAscii = False
        End If
    End Select
End Sub

Public Function IsLeapYear(ByVal CheckYear As Integer) As Boolean

   '/* All years divisible by 4 are leap years */
   '/* with the exception of years that are divisible by 100 and not by 400

    IsLeapYear = CheckYear Mod 4 = 0 And (CheckYear Mod 100 <> 0 Or CheckYear Mod 400 = 0)

End Function

Public Function RetFirstDayOfYear(Optional tWeekDay As VbDayOfWeek = vbMonday, Optional ByVal CurYear As Variant) As Variant
 Dim tDate As Date, FirstDay As Date
    
    If IsMissing(CurYear) Then CurYear = Year(Date)
    tDate = "1/1/" & CurYear
    
    If Weekday(tDate) <> tWeekDay Then
        Do
            tDate = tDate - 1
            If Weekday(tDate) = tWeekDay Then Exit Do
        Loop
    End If
    '/* Calculate first day of new year */
    tDate = DateAdd("d", 1, tDate) + 6
    If Day(tDate) > 6 Then tDate = tDate - 7
    RetFirstDayOfYear = tDate

End Function

Public Function EndOfMonth(ByVal CheckDate As Date) As Date
    EndOfMonth = DateSerial(Year(CheckDate), Month(CheckDate) + 1, 0)
End Function
